diff --git a/rgmanager/src/resources/oracledb.sh b/rgmanager/src/resources/oracledb.sh
index c19d8e52f..c24708d1d 100644
--- a/rgmanager/src/resources/oracledb.sh
+++ b/rgmanager/src/resources/oracledb.sh
@@ -1,1018 +1,1030 @@
 #!/bin/bash
 #
 # Copyright (C) 1997-2003 Sistina Software, Inc.  All rights reserved.
 # Copyright (C) 2004-2013 Red Hat, Inc.  All rights reserved.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
 # as published by the Free Software Foundation; either version 2
 # of the License, or (at your option) any later version.
 #
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 # GNU General Public License for more details.
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 #
 # Author(s):
 #     Hardy Merrill <hmerrill at redhat.com>
 #     Lon Hohberger <lhh at redhat.com>
 #     Michael Moon <Michael dot Moon at oracle.com>
 #     Ryan McCabe <rmccabe at redhat.com>
 #
 # NOTES:
 #
 # (1) You can comment out the LOCKFILE declaration below.  This will prevent
 # the need for this script to access anything outside of the ORACLE_HOME 
 # path.
 #
 # (2) You MUST customize ORACLE_USER, ORACLE_HOME, ORACLE_SID, and
 # ORACLE_HOSTNAME to match your installation if not running from within
 # rgmanager.
 #
 # (3) Do NOT place this script in shared storage; place it in ORACLE_USER's
 # home directory in non-clustered environments and /usr/share/cluster
 # in rgmanager/Red Hat cluster environments.
 #
 # Oracle is a registered trademark of Oracle Corporation.
 # Oracle9i is a trademark of Oracle Corporation.
 # Oracle10g is a trademark of Oracle Corporation.
 # Oracle11g is a trademark of Oracle Corporation.
 # All other trademarks are property of their respective owners.
 #
 
 . $(dirname $0)/ocf-shellfuncs
 . $(dirname $0)/utils/config-utils.sh
 . $(dirname $0)/utils/messages.sh
 . $(dirname $0)/utils/ra-skelet.sh
 
 . /etc/init.d/functions
 
 declare SCRIPT="`basename $0`"
 declare SCRIPTDIR="`dirname $0`"
 
 [ -n "$OCF_RESKEY_user" ] && ORACLE_USER=$OCF_RESKEY_user
 [ -n "$OCF_RESKEY_home" ] && ORACLE_HOME=$OCF_RESKEY_home
 [ -n "$OCF_RESKEY_name" ] && ORACLE_SID=$OCF_RESKEY_name
 [ -n "$OCF_RESKEY_listener_name" ] && ORACLE_LISTENER=$OCF_RESKEY_listener_name
 [ -n "$OCF_RESKEY_lockfile" ] && LOCKFILE=$OCF_RESKEY_lockfile
 [ -n "$OCF_RESKEY_type" ] && ORACLE_TYPE=$OCF_RESKEY_type
 [ -n "$OCF_RESKEY_vhost" ] && ORACLE_HOSTNAME=$OCF_RESKEY_vhost
+[ -n "$OCF_RESKEY_tns_admin" ] && export TNS_ADMIN=$OCF_RESKEY_tns_admin
 
 ######################################################
 # Customize these to match your Oracle installation. #
 ######################################################
 #
 # 1. Oracle user.  Must be the same across all cluster members.  In the event
 #    that this script is run by the super-user, it will automatically switch
 #    to the Oracle user and restart.  Oracle needs to run as the Oracle
 #    user, not as root.
 #
 #[ -n "$ORACLE_USER" ] || ORACLE_USER=oracle
 
 #
 # 2. Oracle home.  This is set up during the installation phase of Oracle.
 #    From the perspective of the cluster, this is generally the mount point
 #    you intend to use as the mount point for your Oracle Infrastructure
 #    service.
 #
 #[ -n "$ORACLE_HOME" ] || ORACLE_HOME=/mnt/oracle/home
 
 #
 # 3. This is your SID.  This is set up during oracle installation as well.
 #
 #[ -n "$ORACLE_SID" ] || ORACLE_SID=orcl
 
 #
 # 4. The oracle user probably doesn't have the permission to write to 
 # /var/lock/subsys, so use the user's home directory.
 #
 #[ -n "$LOCKFILE" ] || LOCKFILE="/home/$ORACLE_USER/.oracle-ias.lock"
 [ -n "$LOCKFILE" ] || LOCKFILE="$ORACLE_HOME/.oracle-ias.lock"
 #[ -n "$LOCKFILE" ] || LOCKFILE="/var/lock/subsys/oracle-ias" # Watch privileges
 
 #
 # 5. Type of Oracle Database.  Currently supported: 10g 10g-iAS(untested!)
 #
 [ -n "$ORACLE_TYPE" ] || ORACLE_TYPE="base-em"
 
 #
 # 6. Oracle virtual hostname.  This is the hostname you gave Oracle during
 #    installation.
 #
 #[ -n "$ORACLE_HOSTNAME" ] || ORACLE_HOSTNAME=svc0.foo.test.com
 
 
 
 ###########################################################################
 ORACLE_TYPE=`echo $ORACLE_TYPE | tr A-Z a-z`
 export ORACLE_USER ORACLE_HOME ORACLE_SID LOCKFILE ORACLE_TYPE
 export ORACLE_HOSTNAME
 
 
 ##########################
 # Set up paths we'll use.  Not all are used by all the different types of
 # Oracle installations
 #
 export LD_LIBRARY_PATH=$ORACLE_HOME/lib:$ORACLE_HOME/opmn/lib
 export PATH=$ORACLE_HOME/bin:$ORACLE_HOME/opmn/bin:$ORACLE_HOME/dcm/bin:$PATH
 
 declare -i	RESTART_RETRIES=0
 declare -r	DB_PROCNAMES="pmon"
 #declare -r	DB_PROCNAMES="pmonXX" # testing
 #declare -r	DB_PROCNAMES="pmon smon dbw0 lgwr"
 
 declare -r	LSNR_PROCNAME="tnslsnr"
 #declare -r	LSNR_PROCNAME="tnslsnrXX" # testing
 
 # clulog will not log messages when run by the oracle user.
 # This is a hack to work around that.
 if [ "`id -u`" = "`id -u $ORACLE_USER`" ]; then
 	ocf_log() {
 		prio=$1
 		shift
 		logger -i -p daemon."$prio" -- "$*"
 	}
 fi
 
 ##########################################################
 # (Hopefully) No user-serviceable parts below this line. #
 ##########################################################
 meta_data()
 {
 	cat <<EOT
 <?xml version="1.0" ?>
 <resource-agent name="oracledb" version="rgmanager 2.0">
     <version>1.0</version>
 
     <longdesc lang="en">
 	Oracle 10g/11g Failover Instance
     </longdesc>
     <shortdesc lang="en">
 	Oracle 10g/11g Failover Instance
     </shortdesc>
 
     <parameters>
         <parameter name="name" primary="1">
 	    <longdesc lang="en">
 		Instance name (SID) of oracle instance
 	    </longdesc>
             <shortdesc lang="en">
 		Oracle SID
             </shortdesc>
 	    <content type="string"/>
         </parameter>
 
         <parameter name="listener_name" unique="1">
 	    <longdesc lang="en">
 		Oracle Listener Instance Name.  If you have multiple 
 		instances of Oracle running, it may be necessary to 
 		have multiple listeners on the same machine with
 		different names.
 	    </longdesc>
             <shortdesc lang="en">
 		Oracle Listener Instance Name
             </shortdesc>
 	    <content type="string"/>
         </parameter>
 
         <parameter name="user" required="1">
 	    <longdesc lang="en">
 		Oracle user name.  This is the user name of the Oracle
 		user which the Oracle AS instance runs as.
 	    </longdesc>
             <shortdesc lang="en">
 		Oracle User Name
             </shortdesc>
 	    <content type="string"/>
         </parameter>
 
         <parameter name="home" required="1">
 	    <longdesc lang="en">
 		This is the Oracle (application, not user) home directory.
 		This is configured when you install Oracle.
 	    </longdesc>
             <shortdesc lang="en">
 		Oracle Home Directory
             </shortdesc>
 	    <content type="string"/>
         </parameter>
 
         <parameter name="type" required="0">
 	    <longdesc lang="en">
 		This is the Oracle installation type:
 		base - Database Instance and Listener only
 		base-11g - Oracle11g Database Instance and Listener Only
 		base-em (or 10g) - Database, Listener, Enterprise Manager,
 				   and iSQL*Plus
 		base-em-11g - Database, Listener, Enterprise Manager dbconsole
 		ias (or 10g-ias) - Internet Application Server (Infrastructure)
 	    </longdesc>
             <shortdesc lang="en">
 		Oracle Installation Type
             </shortdesc>
 	    <content type="string"/>
         </parameter>
 
         <parameter name="vhost" required="0" unique="1">
 	    <longdesc lang="en">
 	        Virtual Hostname matching the installation hostname of
 		Oracle 10g.  Note that during the start/stop of an oracledb
 		resource, your hostname will temporarily be changed to
 		this hostname.  As such, it is recommended that oracledb
 		resources be instanced as part of an exclusive service only.
 	    </longdesc>
             <shortdesc lang="en">
 		Virtual Hostname
             </shortdesc>
 	    <content type="string"/>
         </parameter>
 
+        <parameter name="tns_admin" required="0" unique="1">
+	    <longdesc lang="en">
+			Full path to the directory that contains the Oracle
+        listener tnsnames.ora configuration file.  The shell
+        variable TNS_ADMIN is set to the value provided.
+	    </longdesc>
+            <shortdesc lang="en">
+		Full path to the directory containing tnsnames.ora
+            </shortdesc>
+	    <content type="string"/>
+        </parameter>
     </parameters>
 
     <actions>
         <action name="start" timeout="900"/>
 	<action name="stop" timeout="90"/>
         <action name="recover" timeout="990"/>
 
 	<!-- Checks to see if it's mounted in the right place -->
 	<action name="status" timeout="10"/>
 	<action name="monitor" timeout="10"/>
 
 	<action name="status" depth="10" timeout="30" interval="30"/>
 	<action name="monitor" depth="10" timeout="30" interval="30"/>
 
 	<action name="meta-data" timeout="5"/>
 	<action name="validate-all" timeout="5"/>
     </actions>
 
     <special tag="rgmanager">
 	<attributes maxinstances="1"/>
     </special>
 </resource-agent>
 EOT
 }
 
 #
 # Start Oracle9i/10g/11g (database portion)
 #
 start_db()
 {
 	declare -i rv
 	declare startup_cmd
 	declare startup_stdout
 
 	ocf_log info "Starting Oracle DB $ORACLE_SID"
 
 	# Set up our sqlplus script.  Basically, we're trying to 
 	# capture output in the hopes that it's useful in the case
 	# that something doesn't work properly.
 	startup_cmd="set heading off;\nstartup;\nquit;\n"
 	startup_stdout=$(echo -e "$startup_cmd" | sqlplus -S "/ as sysdba")
 	rv=$?
 
 	# Dump output to syslog for debugging
 	ocf_log debug "[$ORACLE_SID] [$rv] sent $startup_cmd"
 	ocf_log debug "[$ORACLE_SID] [$rv] got $startup_stdout"
 
 	if [ $rv -ne 0 ]; then
 	    ocf_log error "Starting Oracle DB $ORACLE_SID failed, sqlplus returned $rv"
 	    return 1
 	fi
 
 	# If we see:
 	# ORA-.....: failure, we failed
 	# Troubleshooting:
 	#   ORA-00845 - Try rm -f /dev/shm/ora_*
 	#   ORA-01081 - Try echo -e 'shutdown abort;\nquit;'|sqlplus "/ as sysdba"
 	if [[ "$startup_stdout" =~ "ORA-" ]] || [[ "$startup_stdout" =~ "failure" ]]; then
 	    ocf_log error "Starting Oracle DB $ORACLE_SID failed, found errors in stdout"
 	    return 1
 	fi
 
 	ocf_log info "Started Oracle DB $ORACLE_SID successfully"
 	return 0
 }
 
 
 #
 # Stop Oracle (database portion)
 #
 stop_db()
 {
 	declare stop_cmd
 	declare stop_stdout
 	declare -i rv
 	declare how_shutdown="$1"
 
 	if [ -z "$1" ]; then
 		how_shutdown="immediate"
 	fi
 
 	ocf_log info "Stopping Oracle DB $ORACLE_SID $how_shutdown"
 
 	# Setup for Stop ...
 	stop_cmd="set heading off;\nshutdown $how_shutdown;\nquit;\n"
 	stop_stdout=$(echo -e "$stop_cmd" | sqlplus -S "/ as sysdba")
 	rv=$?
 
 	# Log stdout of the stop command
 	ocf_log debug "[$ORACLE_SID] sent stop command $stop_cmd"
 	ocf_log debug "[$ORACLE_SID] got $stop_stdout"
 
 	# sqlplus returned failure. We'll return failed to rhcs
 	if [ $rv -ne 0 ]; then
 	    ocf_log error "Stopping Oracle DB $ORACLE_SID failed, sqlplus returned $rv"
 	    return 1
 	fi
 
 	# If we see 'ORA-' or 'failure' in stdout, we're done.
 	if [[ "$startup_stdout" =~ "ORA-" ]] || [[ "$startup_stdout" =~ "failure" ]]; then
 	    ocf_log error "Stopping Oracle DB $ORACLE_SID failed, errors in stdout"
 	    return 1
 	fi
 
 	ocf_log info "Stopped Oracle DB $ORACLE_SID successfully"
 	return 0
 }
 
 
 #
 # Destroy any remaining processes with refs to $ORACLE_HOME
 #
 force_cleanup()
 {
 	declare pids
 	declare pid
 
 	# Patch from Shane Bradley to fix 471266
 	pids=`ps ax | grep $ORACLE_HOME | grep "ora_.*_${ORACLE_SID}" | grep -v grep | awk '{print $1}'`
 
 	ocf_log error "Not all Oracle processes for $ORACLE_SID exited cleanly, killing"
 
 	for pid in $pids; do
 		kill -9 $pid
 		rv=$?
 		if [ $rv -eq 0 ]; then
 			ocf_log info "Cleanup $ORACLE_SID Killed PID $pid"
 		else
 			ocf_log error "Cleanup $ORACLE_SID Kill PID $pid failed: $rv"
 		fi
 	done
 
 	return 0
 }
 
 
 
 #
 # Wait for oracle processes to exit.  Time out after 60 seconds
 #
 exit_idle()
 {
 	declare -i n=0
 
 	ocf_log debug "Waiting for Oracle processes for $ORACLE_SID to terminate..."
-	while ps ax | grep $ORACLE_HOME | grep -q -v grep; do
+	while ps ax | grep $ORACLE_HOME | grep "ora_.*_${ORACLE_SID}" | grep -v grep | awk '{print $1}'; do
 		if [ $n -ge 90 ]; then
 			ocf_log debug "Timed out while waiting for Oracle processes for $ORACLE_SID to terminate"
 			force_cleanup
 			return 0
 		fi
 		sleep 1
 		((n++))
 	done
 
 	ocf_log debug "All Oracle processes for $ORACLE_SID have terminated"
 	return 0
 }
 
 
 #
 # Get database background process status.  Restart it if it failed and
 # we have seen the lock file.
 #
 get_db_status()
 {
 	declare -i subsys_lock=$1
 	declare -i i=0
 	declare -i rv=0
 	declare ora_procname
 
 	for procname in $DB_PROCNAMES ; do
 
 		ora_procname="ora_${procname}_${ORACLE_SID}"
 		
 		status $ora_procname
 		if [ $? -eq 0 ] ; then
 			# This one's okay; go to the next one.
 			continue
 		fi
 
 		#
 		# We're not supposed to be running, and we are,
 		# in fact, not running...
 		# XXX only works when monitoring one db process; consider
 		# extending in future.
 		#
 		if [ $subsys_lock -ne 0 ]; then
 			return 3
 		fi
 
 		for (( i=$RESTART_RETRIES ; i; i-- )) ; do
 			# this db process is down - stop and
 			# (re)start all ora_XXXX_$ORACLE_SID processes
 			ocf_log info "Restarting Oracle Database $ORACLE_SID"
 			stop_db immediate
 			if [ $? -ne 0 ] ; then
 				# stop failed - return 1
 				ocf_log error "Error stopping Oracle Database $ORACLE_SID"
 				return 1
 			fi
 
 			start_db
 			if [ $? -eq 0 ] ; then
 				# ora_XXXX_$ORACLE_SID processes started
 				# successfully, so break out of the
 				# stop/start # 'for' loop
 				ocf_log info "Restarted Oracle Database $ORACLE_SID successfully"
 				break
 			fi
 		done
 
 		if [ $i -eq 0 ]; then
 			# stop/start's failed - return 1 (failure)
 			ocf_log error "Failed to restart Oracle Database $ORACLE_SID after $RESTART_RETRIES tries"
 			return 1
 		fi
 	done
 	return 0
 }
 
 
 #
 # Get the status of the Oracle listener process
 #
 get_lsnr_status() 
 {
 	declare -i subsys_lock=$1
 	declare -i rv
 
 	ocf_log debug "Checking status for listener $ORACLE_LISTENER"
 	lsnrctl status "$ORACLE_LISTENER" >& /dev/null
 	rv=$?
 	if [ $rv -eq 0 ] ; then
 		ocf_log debug "Listener $ORACLE_LISTENER is up"
 		return 0 # Listener is running fine
 	fi
 
 	# We're not supposed to be running, and we are,
 	# in fact, not running.  Return 3
 	if [ $subsys_lock -ne 0 ]; then
 		ocf_log debug "Listener $ORACLE_LISTENER is stopped as expected"
 		return 3
 	fi
 
 	# Listener is NOT running (but should be) - try to restart
 	for (( i=$RESTART_RETRIES ; i; i-- )) ; do
 		ocf_log info "Listener $ORACLE_LISTENER is down, attempting to restart"
 		lsnrctl start "$ORACLE_LISTENER" >& /dev/null
 		lsnrctl status "$ORACLE_LISTENER" >& /dev/null
 		if [ $? -eq 0 ] ; then
 			ocf_log info "Listener $ORACLE_LISTENER was restarted successfully"
 			break # Listener was (re)started and is running fine
 		fi
 	done
 
 	if [ $i -eq 0 ]; then
 		# stop/start's failed - return 1 (failure)
 		ocf_log error "Failed to restart listener $ORACLE_LISTENER after $RESTART_RETRIES tries"
 		return 1
 	fi
 
 	lsnrctl_stdout=$(lsnrctl status "$ORACLE_LISTENER")
 	rv=$?
 	if [ $rv -ne 0 ] ; then
 		ocf_log error "Starting listener $ORACLE_LISTENER failed: $rv output $lsnrctl_stdout"
 		return 1 # Problem restarting the Listener
 	fi
 
 	ocf_log info "Listener $ORACLE_LISTENER started successfully"
 	return 0 # Success restarting the Listener
 }
 
 
 #
 # usage: get_opmn_proc_status <ias-component> [process-type]
 #
 # Get the status of a specific OPMN-managed process.  If process-type
 # is not specified, assume the process-type is the same as the ias-component.
 # If the lock-file exists (or no lock file is specified), try to restart
 # the given process-type if it is not running.
 #
 get_opmn_proc_status()
 {
 	declare comp=$1
 	declare opmntype=$2
 	declare type_pretty
 	declare _pid _status
 	
 	[ -n "$comp" ] || return 1
 	if [ -z "$opmntype" ]; then
 		opmntype=$comp
 	else
 		type_pretty=" [$opmntype]"
 	fi
 
 	for (( i=$RESTART_RETRIES ; i; i-- )) ; do
 
 		_status=`opmnctl status | grep "^$comp " | grep " $opmntype " | cut -d '|' -f3,4 | sed -e 's/ //g' -e 's/|/ /g'`
 
 		_pid=`echo $_status | cut -f1 -d' '`
 		_status=`echo $_status | cut -f2 -d' '`
 		if [ "${_status}" == "Alive" ] || [ "${_status}" == "Init" ]; then
 			if [ $i -lt $RESTART_RETRIES ] ; then
 				ocf_log info "$comp$type_pretty restarted"
 			fi
 			ocf_log info "$comp$type_pretty (pid $_pid) is running..."
 			break
 		else
 			ocf_log info "$comp$type_pretty is stopped"
 
 			#
 			# Try to restart it, but don't worry if we fail.  OPMN
 			# is supposed to handle restarting these anyway.
 			#
 			# If it's running and you tell OPMN to "start" it,
 			# you will get an error.
 			#
 			# If it's NOT running and you tell OPMN to "restart"
 			# it, you will also get an error.
 			#
 			opmnctl startproc process-type=$opmntype &> /dev/null
 		fi
 	done
 
 	if [ $i -eq 0 ]; then
 		# restarts failed - return 1 (failure)
 		ocf_log error "Failed to restart OPMN process $comp"
 		return 1
 	fi
 
 	return 0
 }
 
 
 #
 # Get the status of the OPMN-managed processes.
 #
 get_opmn_status()
 {
 	declare -i subsys_lock=$1
 	declare -i ct_errors=0
 
 	opmnctl status &> /dev/null
 	if [ $? -eq 2 ]; then
 		#
 		# OPMN not running??
 		#
 		ocf_log info "OPMN is stopped"
 
 		if [ $subsys_lock -eq 0 ]; then
 			#
 			# Don't handle full opmn-restart. XXX
 			#
 			return 1
 		fi
 
 		# That's okay, it's not supposed to be!
 		return 3
 	fi
 
 	#
 	# Print out the PIDs for everyone.
 	#
 	ocf_log info "OPMN is running..."
 	ocf_log info "opmn components:"
 
 	#
 	# Check the OPMN-managed processes
 	#
 	get_opmn_proc_status OID || ((ct_errors++))
 	get_opmn_proc_status HTTP_Server || ((ct_errors++))
 	get_opmn_proc_status OC4J OC4J_SECURITY || ((ct_errors++))
 
 	#
 	# One or more OPMN-managed processes failed and could not be
 	# restarted.
 	#
 	if [ $ct_errors -ne 0 ]; then
 		ocf_log error "$ct_errors errors occurred while restarting OPMN-managed processes"
 		return 1
 	fi
 	return 0
 }
 
 
 #
 # Helps us keep a running status so we know what our ultimate return
 # code will be.  Returns 1 if the $1 and $2 are not equivalent, otherwise
 # returns $1.  The return code is meant to be the next $1 when this is
 # called, so, for example:
 #
 # update_status 0   <-- returns 0
 # update_status $? 0 <-- returns 0
 # update_status $? 3 <-- returns 1 (values different - error condition)
 # update_status $? 1 <-- returns 1 (same, but happen to be error state!)
 #
 # update_status 3
 # update_status $? 3 <-- returns 3
 #
 # (and so forth...)
 #
 update_status()
 {
 	declare -i old_status=$1
 	declare -i new_status=$2
 
 	if [ -z "$2" ]; then
 		return $old_status
 	fi
 
 	if [ $old_status -ne $new_status ]; then
 		return 1
 	fi
 
 	return $old_status
 }
 
 
 #
 # Print an error message to the user and exit.
 #
 oops()
 {
 	ocf_log error "$ORACLE_SID: Fatal: $1 failed validation checks"
 	exit 1
 }
 
 
 #
 # Do some validation on the user-configurable stuff at the beginning of the
 # script.
 #
 validation_checks()
 {
 	ocf_log debug "Validating configuration for $ORACLE_SID"
 
 	#
 	# If the oracle user doesn't exist, we're done.
 	#
 	[ -n "$ORACLE_USER" ] || oops "ORACLE_USER"
 	id -u $ORACLE_USER > /dev/null || oops "ORACLE_USER"
 	id -g $ORACLE_USER > /dev/null || oops "ORACLE_USER"
 
 	#
 	# If the oracle home isn't a directory, we're done
 	#
 	[ -n "$ORACLE_HOME" ] || oops ORACLE_HOME
 	#[ -d "$ORACLE_HOME" ] || oops ORACLE_HOME
 
 	#
 	# If the oracle SID is NULL, we're done
 	#
 	[ -n "$ORACLE_SID" ] || oops ORACLE_SID
 
 	#
 	# If we don't know the type, we're done
 	#
 	if [ "$ORACLE_TYPE" = "base" ]; then
 		# Other names for base
 		ORACLE_TYPE="base"
 	elif [ "$ORACLE_TYPE" = "10g" ] || [ "$ORACLE_TYPE" = "base-em" ]; then
 		ORACLE_TYPE="base-em"
 	elif [ "$ORACLE_TYPE" = "10g-ias" ] || [ "$ORACLE_TYPE" = "ias" ]; then
 		ORACLE_TYPE="ias"
 	elif [ "$ORACLE_TYPE" = "11g" ] || [ "$ORACLE_TYPE" = "base-em-11g" ]; then
 		ORACLE_TYPE="base-em-11g"
 	elif [ "$ORACLE_TYPE" = "base-11g" ]; then
 		ORACLE_TYPE="base-11g"
 	else
 		oops "ORACLE_TYPE $ORACLE_TYPE"
 	fi
 
 	#
 	# If the hostname is zero-length, fix it
 	#
 	[ -n "$ORACLE_HOSTNAME" ] || ORACLE_HOSTNAME=`hostname`
 
 	#
 	# Super user? Automatically change UID and exec as oracle user.
 	# Oracle needs to be run as the Oracle user, not root!
 	#
 	if [ "`id -u`" = "0" ]; then
 		#echo "Restarting $0 as $ORACLE_USER."
 		#
 		# Breaks on RHEL5 
 		# exec sudo -u $ORACLE_USER $0 $*
 		#
 		su $ORACLE_USER -c "$0 $*"
 		exit $?
 	fi
 
 	#
 	# If we're not root and not the Oracle user, we're done.
 	#
 	[ "`id -u`" = "`id -u $ORACLE_USER`" ] || oops "not ORACLE_USER after su"
 	[ "`id -g`" = "`id -g $ORACLE_USER`" ] || oops "not ORACLE_GROUP after su"
 
 	#
 	# Go home.
 	#
 	cd "$ORACLE_HOME"
 
 	ocf_log debug "Validation checks for $ORACLE_SID succeeded"
 	return 0
 }
 
 
 #
 # Start Oracle 9i/10g/11g Application Server Infrastructure
 #
 start_oracle()
 {
 	ocf_log info "Starting service $ORACLE_SID"
 
 	start_db
 	rv=$?
 	if [ $rv -ne 0 ]; then
 		ocf_log error "Starting service $ORACLE_SID failed"
 		return 1
 	fi
 
 	ocf_log info "Starting listener $ORACLE_LISTENER"
 	lsnrctl_stdout=$(lsnrctl start "$ORACLE_LISTENER")
 	rv=$?
 	if [ $rv -ne 0 ]; then
 		ocf_log debug "[$ORACLE_SID] Listener $ORACLE_LISTENER start returned $rv output $lsnrctl_stdout"
 		ocf_log error "Starting service $ORACLE_SID failed"
 		return 1
 	fi
 
 	if [ "$ORACLE_TYPE" = "base-em" ]; then
 		ocf_log info "Starting iSQL*Plus for $ORACLE_SID"
 		isqlplusctl start
 		if [ $? -ne 0 ]; then
 			ocf_log error "iSQL*Plus startup for $ORACLE_SID failed"
 			ocf_log error "Starting service $ORACLE_SID failed"
 			return 1
 		else
 			ocf_log info "iSQL*Plus startup for $ORACLE_SID succeeded"
 		fi
 
 		ocf_log info "Starting Oracle EM DB Console for $ORACLE_SID"
 		emctl start dbconsole
 		if [ $? -ne 0 ]; then
 			ocf_log error "Oracle EM DB Console startup for $ORACLE_SID failed"
 			ocf_log error "Starting service $ORACLE_SID failed"
 			return 1
 		else
 			ocf_log info "Oracle EM DB Console startup for $ORACLE_SID succeeded"
 		fi
 	elif [ "$ORACLE_TYPE" = "ias" ]; then
 		ocf_log info "Starting Oracle EM for $ORACLE_SID"
 		emctl start em
 		if [ $? -ne 0 ]; then
 			ocf_log error "Oracle EM startup for $ORACLE_SID failed"
 			ocf_log error "Starting service $ORACLE_SID failed"
 			return 1
 		else
 			ocf_log info "Oracle EM startup for $ORACLE_SID succeeded"
 		fi
 
 		ocf_log info "Starting iAS Infrastructure for $ORACLE_SID"
 		opmnctl startall
 		if [ $? -ne 0 ]; then
 			ocf_log error "iAS Infrastructure startup for $ORACLE_SID failed"
 			ocf_log error "Starting service $ORACLE_SID failed"
 			return 1
 		else
 			ocf_log info "iAS Infrastructure startup for $ORACLE_SID succeeded"
 		fi
 	elif [ "$ORACLE_TYPE" = "base-em-11g" ]; then
 		ocf_log info "Starting Oracle EM DB Console for $ORACLE_SID"
 		emctl start dbconsole
 		if [ $? -ne 0 ]; then
 			ocf_log error "Oracle EM DB Console startup for $ORACLE_SID failed"
 			ocf_log error "Starting service $ORACLE_SID failed"
 			return 1
 		else
 			ocf_log info "Oracle EM DB Console startup for $ORACLE_SID succeeded"
 		fi
 	fi
 
 	if [ -n "$LOCKFILE" ]; then
 		touch "$LOCKFILE"
 	fi
 
 	ocf_log info "Starting service $ORACLE_SID completed successfully"
 	return 0
 }
 
 
 #
 # Stop Oracle 9i/10g/11g Application Server Infrastructure
 #
 stop_oracle()
 {
 	ocf_log info "Stopping service $ORACLE_SID"
 
 	if ! [ -e "$ORACLE_HOME/bin/lsnrctl" ]; then
 		ocf_log error "Oracle Listener Control is not available ($ORACLE_HOME not mounted?)"
 		return 0
 	fi
 
 	if [ "$ORACLE_TYPE" = "base-em" ]; then
 		ocf_log info "Stopping Oracle EM DB Console for $ORACLE_SID"
 		emctl stop dbconsole
 		if [ $? -ne 0 ]; then
 			ocf_log error "Stopping Oracle EM DB Console for $ORACLE_SID failed"
 			ocf_log error "Stopping service $ORACLE_SID failed"
 			return 1
 		else
 			ocf_log info "Stopping Oracle EM DB Console for $ORACLE_SID succeeded"
 		fi
 
 		ocf_log info "Stopping iSQL*Plus for $ORACLE_SID"
 		isqlplusctl stop
 		if [ $? -ne 0 ]; then
 			ocf_log error "Stopping iSQL*Plus for $ORACLE_SID failed"
 			ocf_log error "Stopping service $ORACLE_SID failed"
 			return 1
 		else
 			ocf_log info "Stopping iSQL*Plus for $ORACLE_SID succeeded"
 		fi
 	elif [ "$ORACLE_TYPE" = "ias" ]; then
 		ocf_log info "Stopping iAS Infrastructure for $ORACLE_SID"
 		opmnctl stopall
 		if [ $? -ne 0 ]; then
 			ocf_log error "Stopping iAS Infrastructure for $ORACLE_SID failed"
 			ocf_log error "Stopping service $ORACLE_SID failed"
 			return 1
 		else
 			ocf_log info "Stopping iAS Infrastructure for $ORACLE_SID succeeded"
 		fi
 
 		ocf_log info "Stopping Oracle EM for $ORACLE_SID"
 		emctl stop em
 		if [ $? -ne 0 ]; then
 			ocf_log error "Stopping Oracle EM for $ORACLE_SID failed"
 			ocf_log error "Stopping service $ORACLE_SID failed"
 			return 1
 		else
 			ocf_log info "Stopping Oracle EM for $ORACLE_SID succeeded"
 		fi
 	elif [ "$ORACLE_TYPE" = "base-em-11g" ]; then
 		ocf_log info "Stopping Oracle EM DB Console for $ORACLE_SID"
 		emctl stop dbconsole
 		if [ $? -ne 0 ]; then
 			ocf_log error "Stopping Oracle EM DB Console for $ORACLE_SID failed"
 			ocf_log error "Stopping service $ORACLE_SID failed"
 			return 1
 		else
 			ocf_log info "Stopping Oracle EM DB Console for $ORACLE_SID succeeded"
 		fi
 	fi
 
 	stop_db immediate || stop_db abort
 	if [ $? -ne 0 ]; then
 		ocf_log error "Stopping service $ORACLE_SID failed"
 		return 1
 	fi
 
 	ocf_log info "Stopping listener $ORACLE_LISTENER for $ORACLE_SID"
 	lsnrctl_stdout=$(lsnrctl stop "$ORACLE_LISTENER")
 	rv=$?
 	if [ $? -ne 0 ]; then
 		ocf_log error "Listener $ORACLE_LISTENER stop failed for $ORACLE_SID: $rv output $lsnrctl_stdout"
 		# XXX - failure?
 	fi
 
 	exit_idle 
 	if [ $? -ne 0 ]; then
 		ocf_log warning "WARNING: Not all Oracle processes exited cleanly for $ORACLE_SID"
 	fi
 
 	if [ -n "$LOCKFILE" ]; then
 		rm -f "$LOCKFILE"
 	fi
 
 	ocf_log info "Stopping service $ORACLE_SID succeeded"
 	return 0
 }
 
 
 #
 # Find and display the status of iAS infrastructure.
 #
 # This has three parts:
 # (1) Oracle database itself
 # (2) Oracle listener process
 # (3) OPMN and OPMN-managed processes
 #
 # - If all are (cleanly) down, we return 3.  In order for this to happen,
 # $LOCKFILE must not exist.  In this case, we try and restart certain parts
 # of the service - as this may be running in a clustered environment.
 #
 # - If some but not all are running (and, if $LOCKFILE exists, we could not
 # restart the failed portions), we return 1 (ERROR)
 #
 # - If all are running, return 0.  In the "all-running" case, we recreate
 # $LOCKFILE if it does not exist.
 #
 status_oracle()
 {
 	declare -i subsys_lock=1
 	declare -i last 
 
 	ocf_log debug "Checking status for $ORACLE_SID depth $depth"
 
 	#
 	# Check for lock file.  Crude and rudimentary, but it works
 	#
 	if [ -z "$LOCKFILE" ] || [ -f "$LOCKFILE" ]; then
 		subsys_lock=0 
 	fi
 
 	# Check database status
 	get_db_status $subsys_lock
 	update_status $? # Start
 	last=$?
 
 	# Check & report listener status
 	get_lsnr_status $subsys_lock
 	update_status $? $last
 	last=$?
 	
 	if [ "$ORACLE_TYPE" = "base-em" ] || [ "$ORACLE_TYPE" = "base-em-11g" ]; then
 		# XXX Add isqlplus status check?!
 		emctl status dbconsole >&/dev/null
 		update_status $? $last
 		last=$?
 	elif [ "$ORACLE_TYPE" = "ias" ]; then
 		# Check & report opmn / opmn-managed process status
 		get_opmn_status $subsys_lock
 		update_status $? $last
 		last=$?
 	fi
 
 	#
 	# No lock file, but everything's running.  Put the lock
 	# file back. XXX - this kosher?
 	#
 	if [ $last -eq 0 ] && [ $subsys_lock -ne 0 ]; then
 		touch "$LOCKFILE"
 	fi
 
 	ocf_log debug "Status returning $last for $ORACLE_SID"
 	return $last
 }
 
 
 ########################
 # Do some real work... #
 ########################
 if [ "$1" = "meta-data" ]; then
 	meta_data
 	exit 0
 fi
 
 validation_checks $*
 
 case $1 in
 	start)
 		start_oracle
 		exit $?
 		;;
 	stop)
 		stop_oracle
 		exit $?
 		;;
 	status|monitor)
 		status_oracle
 		exit $?
 		;;
 	restart)
 		$0 stop || exit $?
 		$0 start || exit $?
 		exit 0
 		;;
 	*)
 		echo "usage: $SCRIPT {start|stop|status|restart|meta-data}"
 		exit 1
 		;;
 esac
 exit 0
diff --git a/rgmanager/src/resources/orainstance.metadata b/rgmanager/src/resources/orainstance.metadata
index f11995d5f..b58617b9d 100644
--- a/rgmanager/src/resources/orainstance.metadata
+++ b/rgmanager/src/resources/orainstance.metadata
@@ -1,86 +1,98 @@
 <?xml version="1.0" ?>
 <!-- $Id: orainstance.metadata 58 2009-06-29 05:15:12Z hevirtan $ -->
 
 <!-- Resource metadata for Oracle DB agent -->
 <resource-agent name="orainstance" version="rgmanager 2.0">
     <version>1.0</version>
 
     <longdesc lang="en">
 	Oracle 10g Failover Instance
     </longdesc>
     <shortdesc lang="en">
 	Oracle 10g Failover Instance
     </shortdesc>
 
     <parameters>
         <parameter name="name" primary="1">
 	    	<longdesc lang="en">
 				Instance name (SID) of oracle instance
 	    	</longdesc>
         	<shortdesc lang="en">
 				Oracle SID
         	</shortdesc>
 	    	<content type="string"/>
         </parameter>
 
         <parameter name="user" required="1">
 	    	<longdesc lang="en">
 				Oracle user name.  This is the user name of the Oracle
 				user which the Oracle instance runs as.
 	    	</longdesc>
         	<shortdesc lang="en">
 				Oracle User Name
         	</shortdesc>
 	    	<content type="string"/>
         </parameter>
 
         <parameter name="home" required="1">
 	    	<longdesc lang="en">
 				This is the Oracle database home directory.
 				This is configured when you install Oracle.
 	    	</longdesc>
         	<shortdesc lang="en">
 				Oracle Home Directory
         	</shortdesc>
 	    	<content type="string"/>
         </parameter>
 
         <parameter name="listeners">
 	    	<longdesc lang="en">
 				List of Oracle listeners which will be started with
 				the database instance. Listener names are separated by
 				whitespace. Defaults to empty which disables listeners.
 	    	</longdesc>
         	<shortdesc lang="en">
 				Oracle listeners
         	</shortdesc>
 	    	<content type="string" default=""/>
         </parameter>
 
         <parameter name="lockfile">
 	    	<longdesc lang="en">
 				Location for lockfile which will be used for checking if
 				the Oracle should be running or not. Defaults to location
 				under /tmp.
 	    	</longdesc>
         	<shortdesc lang="en">
 				Pathname for lockfile
         	</shortdesc>
 	    	<content type="string"/>
         </parameter>
+
+        <parameter name="tns_admin" required="0" unique="1">
+	    <longdesc lang="en">
+			Full path to the directory that contains the Oracle
+        listener tnsnames.ora configuration file.  The shell
+        variable TNS_ADMIN is set to the value provided.
+	    </longdesc>
+            <shortdesc lang="en">
+		Full path to the directory containing tnsnames.ora
+            </shortdesc>
+	    <content type="string"/>
+        </parameter>
     </parameters>
 
     <actions>
         <action name="start" timeout="900"/>
 		<action name="stop" timeout="90"/>
 
 		<!-- Note: status check will also perform recover 
 			 (Oracle DB restart) if the check fails -->
 		<action name="status" timeout="900" interval="1m"/>
 		<action name="monitor" timeout="900" interval="1m"/>
 
 		<action name="meta-data" timeout="0"/>
 		<action name="verify-all" timeout="0"/>
     </actions>
 
 </resource-agent>
diff --git a/rgmanager/src/resources/orainstance.sh b/rgmanager/src/resources/orainstance.sh
index ac71a927b..92547444a 100755
--- a/rgmanager/src/resources/orainstance.sh
+++ b/rgmanager/src/resources/orainstance.sh
@@ -1,576 +1,577 @@
 #!/bin/bash
 #
 # Copyright 2003-2004, 2006-2013 Red Hat, Inc.
 #
 # Author(s):
 #     Hardy Merrill <hmerrill at redhat.com>
 #     Lon Hohberger <lhh at redhat.com>
 #     Michael Moon <Michael dot Moon at oracle.com>
 #     Ryan McCabe <rmccabe at redhat.com>
 #
 # This program is Open Source software.  You may modify and/or redistribute
 # it persuant to the terms of the Open Software License version 2.1, which
 # is available from the following URL and is included herein by reference:
 #
 # 	http://opensource.org/licenses/osl-2.1.php
 #
 # NOTES:
 #
 # (1) You can comment out the LOCKFILE declaration below.  This will prevent
 # the need for this script to access anything outside of the ORACLE_HOME 
 # path.
 #
 # (2) You MUST customize ORACLE_USER, ORACLE_HOME, ORACLE_SID, and
 # ORACLE_HOSTNAME to match your installation if not running from within
 # rgmanager.
 #
 # (3) Do NOT place this script in shared storage; place it in ORACLE_USER's
 # home directory in non-clustered environments and /usr/share/cluster
 # in rgmanager/Red Hat cluster environments.
 #
 # Oracle is a registered trademark of Oracle Corporation.
 # Oracle9i is a trademark of Oracle Corporation.
 # Oracle10g is a trademark of Oracle Corporation.
 # Oracle11g is a trademark of Oracle Corporation.
 # All other trademarks are property of their respective owners.
 #
 #
 # $Id: orainstance.sh 127 2009-08-21 09:17:52Z hevirtan $
 #
 # Original version is distributed with RHCS. The modifications include
 # the following minor changes:
 # - Meta-data moved to a dedicated file
 # - Support for multiple listeners
 # - Disabled EM
 # - SysV init support removed. Only usable with rgmanager
 #
 
 # Grab the global RHCS helper functions
 . $(dirname $0)/ocf-shellfuncs
 . $(dirname $0)/utils/config-utils.sh
 . $(dirname $0)/utils/messages.sh
 . $(dirname $0)/utils/ra-skelet.sh
 
 . /etc/init.d/functions
 
 declare SCRIPT="`basename $0`"
 declare SCRIPTDIR="`dirname $0`"
 
 # Required parameters from rgmanager
 ORACLE_USER=$OCF_RESKEY_user
 ORACLE_HOME=$OCF_RESKEY_home
 ORACLE_SID=$OCF_RESKEY_name
+[ -n "$OCF_RESKEY_tns_admin" ] && export TNS_ADMIN=$OCF_RESKEY_tns_admin
 
 # Optional parameters with default values
 LISTENERS=$OCF_RESKEY_listeners
 LOCKFILE="$ORACLE_HOME/.orainstance-${ORACLE_SID}.lock"
 [ -n "$OCF_RESKEY_lockfile" ] && LOCKFILE=$OCF_RESKEY_lockfile
 
 export LISTENERS ORACLE_USER ORACLE_HOME ORACLE_SID LOCKFILE
 export LD_LIBRARY_PATH=$ORACLE_HOME/lib
 export PATH=$ORACLE_HOME/bin:/bin:/sbin:/usr/bin:/usr/sbin
 
 declare -i	RESTART_RETRIES=3
 declare -r	DB_PROCNAMES="pmon"
 declare -r	LSNR_PROCNAME="tnslsnr"
 
 # clulog will not log messages when run by the oracle user.
 # This is a hack to work around that.
 if [ "`id -u`" = "`id -u $ORACLE_USER`" ]; then
 	ocf_log() {
 		prio=$1
 		shift
 		logger -i -p daemon."$prio" -- "$*"
 	}
 fi
 
 #
 # Start Oracle (database portion)
 #
 start_db() {
 	declare -i rv
 	declare startup_cmd
 	declare startup_stdout
 
 	ocf_log info "Starting Oracle DB $ORACLE_SID"
 
 	# Set up our sqlplus script.  Basically, we're trying to 
 	# capture output in the hopes that it's useful in the case
 	# that something doesn't work properly.
 	startup_cmd="set heading off;\nstartup;\nquit;\n"
 	startup_stdout=$(echo -e "$startup_cmd" | sqlplus -S "/ as sysdba")
 	rv=$?
 
 	# Dump output to syslog for debugging
 	ocf_log debug "[$ORACLE_SID] [$rv] sent $startup_cmd"
 	ocf_log debug "[$ORACLE_SID] [$rv] got $startup_stdout"
 	
 	if [ $rv -ne 0 ]; then
 		ocf_log error "Starting Oracle DB $ORACLE_SID failed, sqlplus returned $rv"
 		return 1
 	fi
 
 	# If we see:
 	# ORA-.....: failure, we failed
 	# Troubleshooting:
 	#   ORA-00845 - Try rm -f /dev/shm/ora_*
 	#   ORA-01081 - Try echo -e 'shutdown abort;\nquit;'|sqlplus "/ as sysdba"
 	if [[ "$startup_stdout" =~ "ORA-" ]] || [[ "$startup_stdout" =~ "failure" ]]; then
 		ocf_log error "Starting Oracle DB $ORACLE_SID failed, found errors in stdout"
 		return 1
 	fi
 
 	ocf_log info "Started Oracle DB $ORACLE_SID successfully"
 	return 0
 }
 
 
 #
 # Stop Oracle (database portion)
 #
 stop_db() {
 	declare stop_cmd
 	declare stop_stdout
 	declare -i rv
 	declare how_shutdown="$1"
 
 	if [ -z "$1" ]; then
 		how_shutdown="immediate"
 	fi
 
 	ocf_log info "Stopping Oracle DB $ORACLE_SID $how_shutdown"
 
 	ora_procname="ora_${DB_PROCNAMES}_${ORACLE_SID}"
 	status $ora_procname
 	if [ $? -ne 0 ]; then
 		ocf_log debug "no pmon process -- DB $ORACLE_SID already stopped"
 		# No pmon process found, db already down
 		return 0
 	fi
 
 	# Setup for Stop ...
 	stop_cmd="set heading off;\nshutdown $how_shutdown;\nquit;\n"
 	stop_stdout=$(echo -e "$stop_cmd" | sqlplus -S "/ as sysdba")
 	rv=$?
 
 	# Log stdout of the stop command
 	ocf_log debug "[$ORACLE_SID] sent stop command $stop_cmd"
 	ocf_log debug "[$ORACLE_SID] got $stop_stdout"
 	
 	# sqlplus returned failure. We'll return failed to rhcs
 	if [ $rv -ne 0 ]; then
 		ocf_log error "Stopping Oracle DB $ORACLE_SID failed, sqlplus returned $rv"
 		return 1
 	fi
 
 	# If we see 'ORA-' or 'failure' in stdout, we're done.
 	if [[ "$startup_stdout" =~ "ORA-" ]] || [[ "$startup_stdout" =~ "failure" ]]; then
 		ocf_log error "Stopping Oracle DB $ORACLE_SID failed, errors in stdout"
 		return 1
 	fi
 
 	ocf_log info "Stopped Oracle DB $ORACLE_SID successfully"
 	return 0
 }
 
 
 #
 # Destroy any remaining processes with refs to $ORACLE_SID
 #
 force_cleanup() {
 	declare pids
 	declare pid
 
 	ocf_log error "Not all Oracle processes for $ORACLE_SID exited cleanly, killing"
 	
 	pids=`ps ax | grep "ora_.*_${ORACLE_SID}" | grep -v grep | awk '{print $1}'`
 
 	for pid in $pids; do
 		kill -9 $pid
 		rv=$?
 		if [ $rv -eq 0 ]; then
 			ocf_log info "Cleanup $ORACLE_SID Killed PID $pid"
 		else
 			ocf_log error "Cleanup $ORACLE_SID Kill PID $pid failed: $rv"
 		fi
 	done
 
 	return 0
 }
 
 
 #
 # Wait for oracle processes to exit.  Time out after 60 seconds
 #
 exit_idle() {
 	declare -i n=0
 	
 	ocf_log debug "Waiting for Oracle processes for $ORACLE_SID to terminate..."
 	while ps ax | grep $ORACLE_SID | grep -q -v $LSNR_PROCNAME | grep -q -v grep; do
 		if [ $n -ge 90 ]; then
 			ocf_log debug "Timed out while waiting for Oracle processes for $ORACLE_SID to terminate"
 			force_cleanup
 			return 0
 		fi
 		sleep 1
 		((n++))
 	done
 
 	ocf_log debug "All Oracle processes for $ORACLE_SID have terminated"
 	return 0
 }
 
 
 #
 # Get database background process status.  Restart it if it failed and
 # we have seen the lock file.
 #
 get_db_status() {
 	declare -i subsys_lock=$1
 	declare -i i=0
 	declare -i rv=0
 	declare ora_procname
 
 	ocf_log debug "Checking status of DB $ORACLE_SID"
 
 	for procname in $DB_PROCNAMES ; do
 		ora_procname="ora_${procname}_${ORACLE_SID}"
 		
 		status $ora_procname
 		if [ $? -eq 0 ] ; then
 			# This one's okay; go to the next one.
 			continue
 		fi
 
 		# We're not supposed to be running, and we are,
 		# in fact, not running...
 		if [ $subsys_lock -ne 0 ]; then
 			ocf_log debug "DB $ORACLE_SID is already stopped"
 			return 3
 		fi
 
 		for (( i=$RESTART_RETRIES ; i; i-- )) ; do
 			# this db process is down - stop and
 			# (re)start all ora_XXXX_$ORACLE_SID processes
 			ocf_log info "Restarting Oracle Database $ORACLE_SID"
 			stop_db
 
 			start_db
 			if [ $? -eq 0 ] ; then
 				# ora_XXXX_$ORACLE_SID processes started
 				# successfully, so break out of the
 				# stop/start # 'for' loop
 				ocf_log info "Restarted Oracle DB $ORACLE_SID successfully"
 				break
 			fi
 		done
 
 		if [ $i -eq 0 ]; then
 			# stop/start's failed - return 1 (failure)
 			ocf_log error "Failed to restart Oracle DB $ORACLE_SID after $RESTART_RETRIES tries"
 			return 1
 		fi
 	done
 
 	ocf_log debug "Checking status of DB $ORACLE_SID success"
 	return 0
 }
 
 
 #
 # Get the status of the Oracle listener process
 #
 get_lsnr_status() {
 	declare -i subsys_lock=$1
 	declare -i rv
 	declare -r LISTENER=$3
 
 	ocf_log debug "Checking status for listener $LISTENER"
 	lsnrctl status "$LISTENER" >& /dev/null
 	rv=$?
 	if [ $rv -eq 0 ] ; then
 		ocf_log debug "Listener $LISTENER is up"
 		return 0 # Listener is running fine
 	fi
 
 	# We're not supposed to be running, and we are,
 	# in fact, not running.  Return 3
 	if [ $subsys_lock -ne 0 ]; then
 		ocf_log debug "Listener $LISTENER is stopped as expected"
 		return 3
 	fi
 
 	# Listener is NOT running (but should be) - try to restart
 	for (( i=$RESTART_RETRIES ; i; i-- )) ; do
 		ocf_log info "Listener $LISTENER is down, attempting to restart"
 		lsnrctl start "$LISTENER" >& /dev/null
 		lsnrctl status "$LISTENER" >& /dev/null
 		if [ $? -eq 0 ]; then
 			ocf_log info "Listener $LISTENER was restarted successfully"
 			break # Listener was (re)started and is running fine
 		fi
 	done
 
 	if [ $i -eq 0 ]; then
 		# stop/start's failed - return 1 (failure)
 		ocf_log error "Failed to restart listener $LISTENER after $RESTART_RETRIES tries"
 		return 1
 	fi
 
 	lsnrctl_stdout=$(lsnrctl status "$LISTENER")
 	rv=$?
 	if [ $rv -ne 0 ] ; then
 		ocf_log error "Starting listener $LISTENER failed: $rv output $lsnrctl_stdout"
 		return 1 # Problem restarting the Listener
 	fi
 
 	ocf_log info "Listener $LISTENER started successfully"
 	return 0 # Success restarting the Listener
 }
 
 
 #
 # Helps us keep a running status so we know what our ultimate return
 # code will be.  Returns 1 if the $1 and $2 are not equivalent, otherwise
 # returns $1.  The return code is meant to be the next $1 when this is
 # called, so, for example:
 #
 # update_status 0   <-- returns 0
 # update_status $? 0 <-- returns 0
 # update_status $? 3 <-- returns 1 (values different - error condition)
 # update_status $? 1 <-- returns 1 (same, but happen to be error state!)
 #
 # update_status 3
 # update_status $? 3 <-- returns 3
 #
 # (and so forth...)
 #
 update_status() {
 	declare -i old_status=$1
 	declare -i new_status=$2
 
 	if [ -z "$2" ]; then
 		return $old_status
 	fi
 
 	if [ $old_status -ne $new_status ]; then
 		ocf_log error "Error: $old_status vs $new_status for $ORACLE_SID - returning 1"
 		return 1
 	fi
 
 	return $old_status
 }
 
 
 #
 # Print an error message to the user and exit.
 #
 oops() {
 	ocf_log error "$ORACLE_SID: Fatal: $1 failed validation checks"
 	exit 1
 }
 
 
 #
 # Do some validation on the user-configurable stuff at the beginning of the
 # script.
 #
 validation_checks() {
 	ocf_log debug "Validating configuration for $ORACLE_SID"
 
 	# If the oracle user doesn't exist, we're done.
 	[ -n "$ORACLE_USER" ] || oops "ORACLE_USER"
 	id -u $ORACLE_USER > /dev/null || oops "ORACLE_USER"
 	id -g $ORACLE_USER > /dev/null || oops "ORACLE_GROUP"
 
 	# If the oracle home isn't a directory, we're done
 	[ -n "$ORACLE_HOME" ] || oops "ORACLE_HOME"
 
 	# If the oracle SID is NULL, we're done
 	[ -n "$ORACLE_SID" ] || oops "ORACLE_SID"
 
 	# Super user? Automatically change UID and exec as oracle user.
 	# Oracle needs to be run as the Oracle user, not root!
 	if [ "`id -u`" = "0" ]; then
 		su $ORACLE_USER -c "$0 $*"
 		exit $?
 	fi
 
 	# If we're not root and not the Oracle user, we're done.
 	[ "`id -u`" = "`id -u $ORACLE_USER`" ] || oops "not ORACLE_USER after su"
 	[ "`id -g`" = "`id -g $ORACLE_USER`" ] || oops "not ORACLE_GROUP after su"
 
 	# Go home.
 	cd "$ORACLE_HOME"
 
 	ocf_log debug "Validation checks for $ORACLE_SID succeeded"
 	return 0
 }
 
 
 #
 # Start Oracle
 #
 start_oracle() {
 	ocf_log info "Starting service $ORACLE_SID"
 
 	start_db
 	rv=$?
 	if [ $rv -ne 0 ]; then
 		ocf_log error "Starting service $ORACLE_SID failed"
 		return 1
 	fi
 
 	for LISTENER in ${LISTENERS}; do
 		ocf_log info "Starting listener $LISTENER"
 		lsnrctl_stdout=$(lsnrctl start "$LISTENER")
 		rv=$?
 		if [ $rv -ne 0 ]; then
 			ocf_log debug "[$ORACLE_SID] Listener $LISTENER start returned $rv output $lsnrctl_stdout"
 			ocf_log error "Starting service $ORACLE_SID failed"
 			return 1
 		fi
 	done
 
 	if [ -n "$LOCKFILE" ]; then
 		touch "$LOCKFILE"
 	fi
 
 	ocf_log info "Starting service $ORACLE_SID completed successfully"
 	return 0
 }
 
 
 #
 # Stop Oracle
 #
 stop_oracle() {
 	ocf_log info "Stopping service $ORACLE_SID"
 
 	if ! [ -e "$ORACLE_HOME/bin/lsnrctl" ]; then
 		ocf_log error "Oracle Listener Control is not available ($ORACLE_HOME not mounted?)"
 		# XXX should this return 1?
 		return 0
 	fi
 
 	stop_db || stop_db abort
 	if [ $? -ne 0 ]; then
 		ocf_log error "Unable to stop DB for $ORACLE_SID"
 		return 1
 	fi
 
 	for LISTENER in ${LISTENERS}; do
 		ocf_log info "Stopping listener $LISTENER for $ORACLE_SID"
 		lsnrctl_stdout=$(lsnrctl stop "$LISTENER")
 		rv=$?
 		if [ $? -ne 0 ]; then
 			ocf_log error "Listener $LISTENER stop failed for $ORACLE_SID: $rv output $lsnrctl_stdout"
 			# XXX - failure?
 		fi
 	done
 
 	exit_idle
 
 	if [ $? -ne 0 ]; then
 		ocf_log error "WARNING: Not all Oracle processes exited cleanly for $ORACLE_SID"
 		# XXX - failure?
 	fi
 
 	if [ -n "$LOCKFILE" ]; then
 		rm -f "$LOCKFILE"
 	fi
 
 	ocf_log info "Stopping service $ORACLE_SID succeeded"
 	return 0
 }
 
 
 #
 # Find and display the status of iAS infrastructure.
 #
 # This has three parts:
 # (1) Oracle database itself
 # (2) Oracle listener process
 # (3) OPMN and OPMN-managed processes
 #
 # - If all are (cleanly) down, we return 3.  In order for this to happen,
 # $LOCKFILE must not exist.  In this case, we try and restart certain parts
 # of the service - as this may be running in a clustered environment.
 #
 # - If some but not all are running (and, if $LOCKFILE exists, we could not
 # restart the failed portions), we return 1 (ERROR)
 #
 # - If all are running, return 0.  In the "all-running" case, we recreate
 # $LOCKFILE if it does not exist.
 #
 status_oracle() {
 	declare -i subsys_lock=1
 	declare -i last 
 	declare -i depth=$1
 
 	ocf_log debug "Checking status for $ORACLE_SID depth $depth"
 
 	# Check for lock file. Crude and rudimentary, but it works
 	if [ -z "$LOCKFILE" ] || [ -f "$LOCKFILE" ]; then
 		subsys_lock=0 
 	fi
 
 	# Check database status
 	get_db_status $subsys_lock $depth
 	update_status $? # Start
 	last=$?
 
 	# Check & report listener status
 	for LISTENER in ${LISTENERS}; do
 		get_lsnr_status $subsys_lock $depth "$LISTENER"
 		update_status $? $last
 		last=$?
 	done
 	
 	# No lock file, but everything's running.  Put the lock
 	# file back. XXX - this kosher?
 	if [ $last -eq 0 ] && [ $subsys_lock -ne 0 ]; then
 		touch "$LOCKFILE"
 	fi
 
 	ocf_log debug "Status returning $last for $ORACLE_SID"
 	return $last
 }
 
 
 ########################
 # Do some real work... #
 ########################
 
 case $1 in
 	meta-data)
 		cat `echo $0 | sed 's/^\(.*\)\.sh$/\1.metadata/'`
 		exit 0
 		;;
 	start)
 		validation_checks $*
 		start_oracle
 		exit $?
 		;;
 	stop)
 		validation_checks $*
 		stop_oracle
 		exit $?
 		;;
 	status|monitor)
 		validation_checks $*
 		status_oracle $OCF_CHECK_LEVEL
 		exit $?
 		;;
 	restart)
 		$0 stop || exit $?
 		$0 start || exit $?
 		exit 0
 		;;
 	*)
 		echo "usage: $SCRIPT {start|stop|restart|status|monitor|meta-data}"
 		exit 1
 		;;
 esac
 
 exit 0
diff --git a/rgmanager/src/resources/oralistener.metadata b/rgmanager/src/resources/oralistener.metadata
index 30f8731a7..0ed04a66e 100644
--- a/rgmanager/src/resources/oralistener.metadata
+++ b/rgmanager/src/resources/oralistener.metadata
@@ -1,61 +1,73 @@
 <?xml version="1.0" ?>
 <!-- $Id: oralistener.metadata 61 2009-06-29 10:01:49Z hevirtan $ -->
 
 <!-- Resource metadata for Oracle listener agent -->
 <resource-agent name="oralistener" version="rgmanager 2.0">
     <version>1.0</version>
 
     <longdesc lang="en">
 	Oracle 10g Listener Instance
     </longdesc>
     <shortdesc lang="en">
 	Oracle 10g Listener Instance
     </shortdesc>
 
     <parameters>
         <parameter name="name" primary="1">
 	    	<longdesc lang="en">
 				Listener name
 	    	</longdesc>
         	<shortdesc lang="en">
 				Listener name
         	</shortdesc>
 	    	<content type="string"/>
         </parameter>
 
         <parameter name="user" required="1">
 	    	<longdesc lang="en">
 				Oracle user name.  This is the user name of the Oracle
 				user which the Oracle instance runs as.
 	    	</longdesc>
         	<shortdesc lang="en">
 				Oracle User Name
         	</shortdesc>
 	    	<content type="string"/>
         </parameter>
 
         <parameter name="home" required="1">
 	    	<longdesc lang="en">
 				This is the Oracle database home directory.
 				This is configured when you install Oracle.
 	    	</longdesc>
         	<shortdesc lang="en">
 				Oracle Home Directory
         	</shortdesc>
 	    	<content type="string"/>
         </parameter>
+
+        <parameter name="tns_admin" required="0" unique="1">
+	    <longdesc lang="en">
+			Full path to the directory that contains the Oracle
+        listener tnsnames.ora configuration file.  The shell
+        variable TNS_ADMIN is set to the value provided.
+	    </longdesc>
+            <shortdesc lang="en">
+		Full path to the directory containing tnsnames.ora
+            </shortdesc>
+	    <content type="string"/>
+        </parameter>
     </parameters>
 
     <actions>
         <action name="start" timeout="90"/>
 		<action name="stop" timeout="30"/>
 		<!-- <action name="recover" timeout="90"/> -->
 
 		<action name="status" timeout="90" interval="5m"/>
 		<action name="monitor" timeout="90" interval="5m"/>
 
 		<action name="meta-data" timeout="0"/>
 		<action name="verify-all" timeout="0"/>
     </actions>
 
 </resource-agent>
diff --git a/rgmanager/src/resources/oralistener.sh b/rgmanager/src/resources/oralistener.sh
index 30b8e069e..90808ed42 100755
--- a/rgmanager/src/resources/oralistener.sh
+++ b/rgmanager/src/resources/oralistener.sh
@@ -1,190 +1,191 @@
 #!/bin/bash
 #
 # Red Hat Cluster Suite resource agent for controlling Oracle 10g
 # listener instances. This script will start, stop and monitor running
 # listeners.
 #
 # start:    Will start given listener instance
 #
 # stop:     Will stop given listener instance
 #
 # monitor:  Will check that the listener is OK by calling lsnrctl status
 #
 #
 # Copyright (C) 1997-2003 Sistina Software, Inc.  All rights reserved.
 # Copyright (C) 2004-2013 Red Hat, Inc.  All rights reserved.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
 # as published by the Free Software Foundation; either version 2
 # of the License, or (at your option) any later version.
 #
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 # GNU General Public License for more details.
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 #
 
 # Grab the global RHCS helper functions
 . $(dirname $0)/ocf-shellfuncs
 . $(dirname $0)/utils/config-utils.sh
 . $(dirname $0)/utils/messages.sh
 . $(dirname $0)/utils/ra-skelet.sh
 
 declare -i	RESTART_RETRIES=3
 
 ORACLE_USER=$OCF_RESKEY_user
 ORACLE_HOME=$OCF_RESKEY_home
 LISTENER=$OCF_RESKEY_name
+[ -n "$OCF_RESKEY_tns_admin" ] && export TNS_ADMIN=$OCF_RESKEY_tns_admin
 
 LC_ALL=C
 LANG=C
 PATH=$ORACLE_HOME/bin:/bin:/sbin:/usr/bin:/usr/sbin
 export LC_ALL LANG PATH ORACLE_USER ORACLE_HOME
 
 # clulog will not log messages when run by the oracle user.
 # This is a hack to work around that.
 if [ "`id -u`" = "`id -u $ORACLE_USER`" ]; then
 	ocf_log() {
 		prio=$1
 		shift
 		logger -i -p daemon."$prio" -- "$*"
 	}
 fi
 
 verify_all() {
 	ocf_log debug "Validating configuration for $LISTENER"
 
 	if [ -z "$OCF_RESKEY_name" ]; then
 		ocf_log error "Validation for $LISTENER failed: Invalid name of service (listener name)"
 		return $OCF_ERR_ARGS
 	fi
 
 	if [ -z "$OCF_RESKEY_home" ]; then
 		ocf_log error "Validation for $LISTENER failed: No Oracle home specified."
 		return $OCF_ERR_ARGS
 	fi
 
 	if [ -z "$OCF_RESKEY_user" ]; then
 		ocf_log error "Validation for $LISTENER failed: No Oracle username specified."
 		return $OCF_ERR_ARGS
 	fi
  
 	# Super user? Automatically change UID and exec as oracle user.
 	# Oracle needs to be run as the Oracle user, not root!
 	if [ "`id -u`" = "0" ]; then
 		su $OCF_RESKEY_user -c "$0 $*"
 		exit $?
 	fi
 
 	# Make sure the lsnrctl binary is in our $PATH
 	if [ ! -x $(which lsnrctl) ]; then
 		ocf_log error "Validation for $LISTENER failed: Unable to locate lsnrctl command from path! ($PATH)"
 		return $OCF_ERR_GENERIC
 	fi
 
 	ocf_log debug "Validation checks for $LISTENER succeeded"
 	return 0
 }
 
 start() {
 	ocf_log info "Starting listener $LISTENER"
 	lsnrctl_stdout=$(lsnrctl start "$LISTENER")
 	if [ $? -ne 0 ]; then
 		ocf_log error "start listener $LISTENER failed $lsnrctl_stdout"
 		return $OCF_ERR_GENERIC
 	fi
 
 	ocf_log info "Listener $LISTENER started successfully"
 	return 0
 }
  
 stop() {
 	ocf_log info "Stopping listener $LISTENER"
 
 	lsnrctl_stdout=$(lsnrctl stop "$LISTENER")
 	if [ $? -ne 0 ]; then
 		ocf_log debug "stop listener $LISTENER failed $lsnrctl_stdout"
 		return $OCF_ERR_GENERIC
 	fi
 
 	ocf_log info "Listener $LISTENER stopped successfully"
 	return 0
 }
  
 monitor() {
 	declare -i depth=$1
 
 	ocf_log debug "Checking status for listener $LISTENER depth $depth"
 	lsnrctl status "$LISTENER" >& /dev/null
 	if [ $? -ne 0 ]; then
 		ocf_log error "Listener $LISTENER not running"
 		return $OCF_ERR_GENERIC
 	fi
 
 	ocf_log debug "Listener $LISTENER is up"
 	return 0 # Listener is running fine
 }
 
 recover() {
 	ocf_log debug "Recovering listener $LISTENER"
 
 	for (( i=$RESTART_RETRIES ; i; i-- )); do
 		start
 		if [ $? -eq 0 ] ; then
 			ocf_log debug "Restarted listener $LISTENER successfully"
 			break
 		fi
 	done
 
 	if [ $i -eq 0 ]; then
 		# stop/start's failed - return 1 (failure)
 		ocf_log debug "Failed to restart listener $LISTENER after $RESTART_RETRIES tries"
 		return 1
 	fi
 
 	status
 	if [ $? -ne 0 ] ; then
 		ocf_log debug "Failed to restart listener $LISTENER"
 		return 1 # Problem restarting the Listener
 	fi
 
 	ocf_log debug "Restarted listener $LISTENER successfully"
 	return 0 # Success restarting the Listener
 }
 
 case $1 in
 	meta-data)
 		cat `echo $0 | sed 's/^\(.*\)\.sh$/\1.metadata/'`
 		exit 0
 		;;
 	verify-all)
 		verify_all $*
 		exit $?
 		;;
 	start)
 		verify_all $* && start
 		exit $?
 		;;
 	stop)
 		verify_all $* && stop
 		exit $?
 		;;
 	recover)
 		verify_all $* && recover
 		exit $?
 		;;
 	status|monitor)
 		verify_all $*
 		monitor $OCF_CHECK_LEVEL
 		exit $?
 		;;
 	*)
 		echo "Usage: $0 {start|stop|recover|monitor|status|meta-data|verify-all}"
 		exit $OCF_ERR_GENERIC
 		;;
 esac